generic: test deadlock on O_DIRECT|O_DSYNC
[xfstests-dev.git] / tests / generic / 170
1 #! /bin/bash
2 # SPDX-License-Identifier: GPL-2.0
3 # Copyright (c) 2015 Oracle, Inc.  All Rights Reserved.
4 #
5 # FS QA Test No. 170
6 #
7 # Test for races or FS corruption when DIO writing to a file that's also
8 # the target of a reflink operation.
9 #
10 seq=`basename $0`
11 seqres=$RESULT_DIR/$seq
12 echo "QA output created by $seq"
13
14 here=`pwd`
15 tmp=/tmp/$$
16 status=1        # failure is the default!
17 trap "_cleanup; exit \$status" 0 1 2 3 7 15
18
19 _cleanup()
20 {
21     cd /
22     rm -rf $tmp.* $finished_file
23     wait
24 }
25
26 # get standard environment, filters and checks
27 . ./common/rc
28 . ./common/filter
29 . ./common/reflink
30
31 # real QA test starts here
32 _supported_os Linux
33 _require_scratch_reflink
34 _require_odirect
35
36 echo "Format and mount"
37 _scratch_mkfs > $seqres.full 2>&1
38 _scratch_mount >> $seqres.full 2>&1
39
40 testdir=$SCRATCH_MNT/test-$seq
41 finished_file=/tmp/finished
42 rm -rf $finished_file
43 mkdir $testdir
44
45 loops=1024
46 nr_loops=$((loops - 1))
47 blksz=65536
48
49 echo "Initialize files"
50 echo >> $seqres.full
51 _pwrite_byte 0x61 0 $((loops * blksz)) $testdir/file1 >> $seqres.full
52 _pwrite_byte 0x62 0 $((loops * blksz)) $testdir/file2 >> $seqres.full
53 _scratch_cycle_mount
54
55 # Direct I/O overwriter...
56 overwrite() {
57         while [ ! -e $finished_file ]; do
58                 seq $nr_loops -1 0 | while read i; do
59                         _pwrite_byte 0x63 $((i * blksz)) $blksz -d $testdir/file2 >> $seqres.full
60                 done
61         done
62 }
63
64 echo "Reflink and dio write the target"
65 overwrite &
66 seq 1 10 | while read j; do
67         seq 0 $nr_loops | while read i; do
68                 _reflink_range  $testdir/file1 $((i * blksz)) \
69                                 $testdir/file2 $((i * blksz)) $blksz >> $seqres.full
70                 [ $? -ne 0 ] && exit
71         done
72 done
73 touch $finished_file
74 wait
75
76 # success, all done
77 status=0
78 exit